﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;


public abstract class ActivatableClass : MonoBehaviour{

	[SerializeField]protected bool fullyActive;

	public bool FullyActive {
		get {
			return fullyActive;
		}
	}

	protected virtual void SetReferences(){
		
	}

	public void CallOnActive(){
		Activate ();
	}

	protected virtual void Activate(){
		
	}

	public void CallDeactivate(){
		Deactivate ();
	}

	protected virtual void Deactivate(){
		this.enabled = false;
	}
}
