﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class GameManager : MonoBehaviour {
	
	public GameObject player;
	[HideInInspector] public GameObject gameManager;
	//[HideInInspector] public LevelManagerClass levelManager;
	[HideInInspector] public UiManager uiManager;
    //[HideInInspector] public SoundManager soundManager;
    AudioSource musicSource = null;
    [SerializeField] AudioClip deathJingle = null;

	public static GameManager instance;

	void Awake(){
		instance = this;

	}

    void Start()
    {
        gameManager = gameObject;
        uiManager = gameObject.GetComponent<UiManager>();
        musicSource = GetComponent<AudioSource>();
        //soundManager = gameObject.GetComponent<SoundManager> ();
        PauseEventClass.PauseEvent += OnPauseEvent;
        EventManager.SubscribeGameOver(delegate
        {
            OnGameOver();

        });
    }

    public void GameWin()
    {
        EventManager.CallWinGame();
    }

    void OnGameOver()
    {
       // musicSource.clip = deathJingle;
        //musicSource.Play();
    }

    void OnPauseEvent()
    {
        Time.timeScale = 0;
    }

    //Veryfies if there is a certain ammount available to use
    public bool VerifyAmmountInt(int curValue ,int required){
		if (curValue >= required) {
			return true;
		}
		else{
			return false;
		}
	}

	public float GetDistance(Vector2 origin,Vector2 destiny){
		float dis = (destiny - origin).magnitude; 
		return dis;
	}
	
}
