﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class InvokeByTriggerSCR : MonoBehaviour {
	[System.Serializable]
	struct InvokeStruct{
		public MonoBehaviour script;
		public string tag;
		public string functionName;
		public float invokeDelay;
	}
		
	[SerializeField] InvokeStruct[] invokeArray;


	void OnTriggerEnter2D(Collider2D coll){
		for (int i = 0; i < invokeArray.Length; i++) {
			if (coll.gameObject.tag == invokeArray[i].tag) {
				if (invokeArray[i].invokeDelay < 0) {
					invokeArray[i].invokeDelay = 0;
					print (gameObject.name + ": Delay below 0");
				}
				invokeArray[i].script.Invoke (invokeArray[i].functionName, invokeArray[i].invokeDelay);
			}
		}
        print("Triggered");
	}
}