﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class JumpCheckerScript : MonoBehaviour {

	[SerializeField] private PlayerMovBehaviour playerMovSCR;
	[SerializeField] Animator playerAnimator;
    [SerializeField] private PlayerSoundBehaviour soundBehaviour = null;

    private void Start()
    {
        playerAnimator = GetComponentInParent<Animator>();
        soundBehaviour = GetComponentInParent<PlayerSoundBehaviour>();
    }

    void OnCollisionStay2D(Collision2D coll){

		if (coll != null) {
			if (coll.gameObject.tag != "NoJump" && coll.gameObject.tag != "Player" &&
             GetComponentInParent<Rigidbody2D>().velocity.y == 0) {
				if (!playerMovSCR.canJump) {
					//soundBehaviour.PlayLandSounds ();
				}
				playerMovSCR.canJump = true;
				playerAnimator.SetBool ("jump", !playerMovSCR.canJump);
            

			}
            IForceEffect force = coll.gameObject.GetComponent<IForceEffect>();

            if (force !=null)
            {
                transform.parent.Translate(force.GetCurForce() * Time.deltaTime);

            }
        }
	}

    private void OnCollisionEnter2D(Collision2D coll)
    {
        if (coll.gameObject.tag == "Platform")
        {
            Land();
            soundBehaviour.PlayLandSounds();
        }
        if(coll.gameObject.tag == "Tramps")
        {
            Land();
            soundBehaviour.PlayJumpSounds();
            
        }

    }

    void Land()
    {
        playerMovSCR.canJump = false;
        playerAnimator.SetBool("jump", !playerMovSCR.canJump);
        print("HELLO");
    }

}
