﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class LavaBehaviour : MonoBehaviour {

	[SerializeField] AudioClip lavaBurn;

	void OnTriggerEnter2D(Collider2D coll){
		if(coll.gameObject.GetComponent<LivingClass>()){
			if (coll.gameObject.GetComponent<LivingClass> () is ILavaDamagable) {
				GetComponent<AudioSource> ().PlayOneShot (lavaBurn);
			}
		}
		if (coll.gameObject.GetComponent<Rigidbody2D> ()) {
			Rigidbody2D collRigid = coll.gameObject.GetComponent<Rigidbody2D> ();
			if (collRigid.bodyType == RigidbodyType2D.Dynamic) {
				collRigid.drag = 4;
			}
		}
	}

	void OnTriggerExit2D(Collider2D coll){
		if (coll.gameObject.GetComponent<Rigidbody2D> ()) {
			Rigidbody2D collRigid = coll.gameObject.GetComponent<Rigidbody2D> ();
			if (collRigid.bodyType == RigidbodyType2D.Dynamic) {
				collRigid.drag = 0;
			}
		}
	}

	void OnTriggerStay2D(Collider2D coll){
		if(coll.gameObject.GetComponent<LivingClass>()){
			if (coll.gameObject.GetComponent<LivingClass> () is ILavaDamagable) {
				coll.gameObject.GetComponent<ILavaDamagable> ().Burn (10);
			}
		}
	}

}
