﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public abstract class LivingClass : MonoBehaviour {

	[SerializeField]protected float hp;
	protected float maxHp;
	protected float healthRatio;
	protected bool isAlive;

	protected virtual void Start(){
		isAlive = true;
		UpdateHealth ();
	}

	protected virtual void Update(){
		if (CheckHp ()) {
			AliveUpdate ();	
		} else {
			if (isAlive) {
				Death ();
			} else {
				DeathUpdate ();
			}
		}
	}

	protected virtual void AliveUpdate(){
		
	}

	protected virtual void UpdateHealth(){
		healthRatio = hp / maxHp;
	}

	protected virtual void DeathUpdate(){
		
	}
		
	protected float ModifyHp(float curHp,float maxHp, float modifier, string action){
		
		switch (action) {
		case "Heal":
			curHp += modifier;
			if (curHp > maxHp) {
				curHp = maxHp;
			}
			break;
		case "Suffer":
			curHp -= modifier;
			if (curHp < 0) {
				curHp = 0;
			}
			OnSuffer ();
			break;

		default:
			print (gameObject.name + "Hp Action does not exist, please check ModifyHp()");
			break;
		}
		UpdateHealth ();
		return curHp;
	}

	protected virtual void OnSuffer(){
		
	}

	protected virtual void Revive(){
		hp = maxHp;
		isAlive = true;
	}

	protected virtual void Death(){
		isAlive = false;
	}

	protected virtual bool CheckHp(){
		if (hp > 0) {
			return true;
		} else {
			return false;
		}
	}
}
