﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public abstract class MobClass : LivingClass {

   	protected MobMovClass moveScript;
	protected Animator anim;
	protected float colldamage;

	public float Colldamage {
		get {
			return colldamage;
		}
	}

	protected virtual void SetReferences(){
		moveScript = GetComponent<MobMovClass> ();
		anim = GetComponent<Animator> ();
	}

	protected override void Start(){
		base.Start ();
		SetReferences ();
	}

	public virtual void CallAnimation(string animation){

		if (animation == "Idle") {
			CallIdleAnimation ();
			return;
		}
		if(animation == "Move"){
			CallMoveAnimation ();
			return;
		}
	}

	protected virtual void CallIdleAnimation(){
		anim.SetBool ("moving", false);
	}
	protected virtual void CallMoveAnimation(){
		anim.SetBool ("moving", true);
	}

	protected override void Death ()
	{
		base.Death ();
		moveScript.enabled = false;
	}

	protected override void Revive ()
	{
		base.Revive ();
		moveScript.enabled = true;
	}

}