﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PlayerGun : MonoBehaviour {

    private float animDelay = 0.2f;
    [Range(0, 1000)] float shotCool;
    [SerializeField] GameObject bulletPrefab;
    GameObject shot = null;
    [HideInInspector] public Vector2 lastClickPos;
    [SerializeField] float shootCoolMax = 0.5f;
    [SerializeField] Transform bulletSpot = null;
    Vector3 bulletDirection;
    float bulletSpeed = 3;
    int bulletDamage = 0;
    Vector2 direction = new Vector2();
    // Update is called once per frame
    void Update() {
        Shoot();
    }

    void Shoot() {
        shotCool -= Time.deltaTime;

        if (Input.GetButtonDown("Fire1") && shotCool <= 0) {
            gameObject.GetComponent<Animator>().SetTrigger("shot");
            lastClickPos = new Vector2(Camera.main.ScreenToWorldPoint(Input.mousePosition).x,
             Camera.main.ScreenToWorldPoint(Input.mousePosition).y);
            Vector2 lastTapPos = new Vector2(Camera.main.ScreenToWorldPoint(Input.mousePosition).x, Camera.main.ScreenToWorldPoint(Input.mousePosition).y);
            direction = lastTapPos - (Vector2)transform.position;
            if (Input.GetButton("Fire1"))
            {
                //Rotates
                float angle = Mathf.Atan2(direction.y, direction.x) * Mathf.Rad2Deg;//Determines the angle of vector dir

                transform.rotation = Quaternion.AngleAxis(angle - 90, Vector3.forward);
                Shoot();
                Invoke("CreateShot", animDelay);
                shotCool = shootCoolMax;
            }
        }
    }
    void CreateShot()
    {
        shot = Instantiate(bulletPrefab, bulletSpot.position, transform.rotation);
        shot.GetComponent<BulletClass>().dir = bulletDirection;
        shot.GetComponent<BulletClass>().movSpeed = bulletSpeed;
        shot.GetComponent<BulletClass>().damage = bulletDamage;
        //PlayFireSounds();
    }
}
