﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;


public class PlayerHealthBehaviour : LivingClass, ILavaDamagable {

	[SerializeField] protected PlayerSoundBehaviour playerSoundScr = null;
	
	[SerializeField] protected Animator playerAnimator;
	//protected PlayerController playerController;

	float regenSpeed;
	float regenTimer;
	const float regenTimerMax = 3;

	public bool IsAlive {
		get {
			return isAlive;
		}
	}


	protected override void Start ()
	{
		SetReferences ();
		maxHp = 1;
		hp = 1;
		regenSpeed = 10;
		base.Start ();

	}

	protected void SetReferences(){
        playerSoundScr = GetComponent<PlayerSoundBehaviour>();
	}

	protected override void AliveUpdate ()
	{
		base.AliveUpdate ();
		regenTimer -= Time.deltaTime;
		if (regenTimer < 0) {
			hp = ModifyHp (hp, maxHp, ((regenSpeed * maxHp)/100)  * Time.deltaTime, "Heal");
		}
	}

	protected override void OnSuffer ()
	{
		base.OnSuffer ();
		regenTimer = regenTimerMax;
	}

	protected override void UpdateHealth ()
	{
		base.UpdateHealth ();
		//playerSoundScr.PlayPlayerDeath (healthRatio);
		//playerUIScr.UpdateHealthUi (healthRatio);
	}

	protected void OnCollisionEnter2D(Collision2D coll){
		if (coll.gameObject.tag == "Mob") {
			hp = ModifyHp(hp,maxHp,coll.gameObject.GetComponent<MobClass> ().Colldamage,"Suffer");
		}
	}
		
	protected override void Death ()
	{
		base.Death ();
		print ("dead1!!!!");
        playerSoundScr.PlayPlayerDeath();
        EventManager.CallGameOver();
        PauseEventClass.CallPause();
		//playerAnimator.SetTrigger ("dead");
		//playerAnimator.updateMode = AnimatorUpdateMode.UnscaledTime;
		//playerSoundScr.PlayDeathJingle();
		//StartCoroutine (GameManager.instance.UiManager.EndGame());
	}

    public void Burn(float damage)
    {
        hp = ModifyHp(hp, maxHp, damage * Time.deltaTime, "Suffer");
    }
}
