﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PlayerMovBehaviour : MonoBehaviour {
    Rigidbody2D rigid = null;
    [SerializeField] float movSpeed = 9;
    [SerializeField] float jumpforce = 7;
    public bool canJump = false;
    [SerializeField] private Animator playerAnim = null;
    [SerializeField] SpriteRenderer sprImage = null;

	// Use this for initialization
	void Start () {
        SetReferences();
	}

    void SetReferences()
    {
        rigid = GetComponent<Rigidbody2D>();
        playerAnim = GetComponent<Animator>();
        sprImage = GetComponent<SpriteRenderer>();
    }

    // Update is called once per frame
    private void FixedUpdate()
    {
        Move();
    }

    void Move() {
        float h = Input.GetAxis("Horizontal");

        Vector3 pos = new Vector3(h * movSpeed * Time.deltaTime, 0,0);


        if (Input.GetButtonDown("Jump") && canJump) {
            //Jumoperssssszzz
            rigid.AddForce(new Vector2(0, jumpforce), ForceMode2D.Impulse);
            playerAnim.SetBool("jump", canJump);
            canJump = false;

        }


        playerAnim.SetFloat("h", Mathf.Abs(h));

        transform.Translate(pos);

        if (h > 0)
        {
            gameObject.GetComponent<SpriteRenderer>().flipX = false;
        }
        else if (h < 0)
        {
            gameObject.GetComponent<SpriteRenderer>().flipX = true;
        }

    }
}
