﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Audio;

public class PlayerSoundBehaviour : SoundClass {

	[SerializeField] protected AudioSource source;

	protected override void SetReferences(){
		base.SetReferences ();
		source = GetComponent<AudioSource> ();
	}

	protected void PlayPlayerSound(int num){
		source.outputAudioMixerGroup = sounds[num].mixer;
		PlayRandomInArray (sounds[num].soundArray, source);
	}
    /*
	public void PlayStepSounds(){
		PlayPlayerSound (0);
	}
    */
	public void PlayJumpSounds(){
		PlayPlayerSound (0);
	}

	public void PlayLandSounds(){
		PlayPlayerSound (1);
	}

/*	public void PlayHurtSounds(){
		PlayPlayerSound (3);
	}
*/
	public void PlayPlayerDeath(){
        //loopSources [0].volume = 1 - healthRatio;
        // [0].pitch = 2 - healthRatio;
        PlayPlayerSound(2);
    }

	public void StopPlayerDeath(){
		StopAllLoops ();
	}
}
