﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ProjectileClass : MonoBehaviour {

	[HideInInspector] public float movSpeed;
	[HideInInspector] public Vector2 dir;
	protected float autoDestroyTimer;

	protected Vector2 startPos;
	protected float maxRange;



	// Use this for initialization
	protected virtual void Start () {
		startPos = transform.position;
		MoveStart ();
	}

	protected virtual void Update(){
		AutoDestroy();
	}

	protected virtual void MoveStart(){
		dir.Normalize ();
		GetComponent<Rigidbody2D> ().AddForce (dir * movSpeed);
	}

	protected virtual void AutoDestroy(){//Auto Destroy on time limit and range;
		autoDestroyTimer -= Time.deltaTime;
		if (autoDestroyTimer <= 0 || GameManager.instance.GetDistance(startPos,gameObject.transform.position) >= maxRange) {
			Destroy (gameObject);
		}
	}
}
